#!/usr/bin/env python
## -*- coding: iso-8859-15 -*-
# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!

#ClearWeatherScreenlet (c) Whise <helder.fraga@hotmail.com>
# 中国天气 li_likun@sohu.com 

import re
from urllib import urlopen
import screenlets
from screenlets.options import StringOption, BoolOption, ColorOption, FontOption
import pygtk
pygtk.require('2.0')
import cairo
import pango
import sys
import gobject
import time
import datetime
import threading
import thread
import math
import cPickle as pickle
import gtk
from gtk import gdk
import os
from screenlets import Plugins
proxy = Plugins.importAPI('Proxy')
class WeatherDataClass:
	ZIP = ''
	SunRise =  ''
	SunDown =  ''
	Weather = [] 
	def __init__(self, text="", **keyword_args):
		ZIP=''
		SunRise =  ''
		SunDown =  ''
		self.Weather=[]
class ChinaClearWeatherScreenlet(screenlets.Screenlet):
	"""中国境内的天气查询"""
			
	# default meta-info for Screenlets
	__name__ = 'ChinaClearWeatherScreenlet'
	__version__ = '0.8'
	__author__ = 'by lk , 邮件: li_likun@sohu.com'
	__desc__ = '改自ClearWeather,将查询网址改为中国天气网'

	# internals
	__timeout = None
	#update_interval = 300
	update_interval = 300
	show_error_message = 1


	tooltipDelay = None	
	buttonDet =  0

	lasty = 0
	lastx = 0   ## the cursor position inside the window (is there a better way to do this??)
	over_button = 1

	bShowTip = True
	ZIP = "兖州"
	use_metric = True
	show_daytemp = True
	mini = False
	font = 'Sans'
	font_color = (1,1,1, 0.8)
	background_color = (0,0,0, 0.8)
	strCityID = ''



		
	latest = WeatherDataClass()          ## the most recent settings we could get...
	latestHourly = []

	updated_recently = 0 ## don't keep showing the error messages until a connection has been established
			     ## and then lost again.
	
	# constructor
	def __init__(self, text="", **keyword_args):
		#call super (and not show window yet)
		screenlets.Screenlet.__init__(self, width=int(132 * self.scale), height=int(100 * self.scale),uses_theme=True, **keyword_args) 
		# set theme
		self.theme_name = "default"
		# init the timeout function
		self.update_interval = self.update_interval
                self.add_options_group('Weather',
                        'The weather widget settings')
                self.add_option(StringOption('Weather', 'ZIP',
                        str(self.ZIP), '城市', '查询天气的城市'), realtime=False)
		self.add_option(BoolOption('Weather', 'show_error_message', 
			bool(self.show_error_message), '显示错误提示', 
			'城市无效时显示提示'))
		self.add_option(BoolOption('Weather', 'mini',
			bool(self.mini), '使用精简模式',
			'切换到精简模式'))
		self.add_option(BoolOption('Weather', 'show_daytemp',
			bool(self.show_daytemp), '显示四天的温度',
			'显示下方四天天气的最高最低气温'))
		self.add_option(BoolOption('Weather', 'bShowTip',
			bool(self.bShowTip), '天气提示 ',
			'鼠标左键单击显示详细天气'))
		self.add_option(FontOption('Weather','font', 
			self.font, '字体', 
			'字体'))
		self.add_option(ColorOption('Weather','font_color', 
			self.font_color, '文本颜色', '文本颜色'))
		self.add_option(ColorOption('Weather','background_color', 
			self.background_color, '背景颜色(默认皮肤)', '只在使用默认皮肤时有效'))
	
	# attribute-"setter", handles setting of attributes
	def __setattr__(self, name, value):
		# call Screenlet.__setattr__ in baseclass (ESSENTIAL!!!!)
		screenlets.Screenlet.__setattr__(self, name, value)
		# check for this Screenlet's attributes, we are interested in:
		if name == "ZIP":
			self.__dict__[name] = value
			gobject.idle_add(self.update_weather_data)
		if name == "update_interval":
			if value > 0:
				self.__dict__['update_interval'] = value
				if self.__timeout:
					gobject.source_remove(self.__timeout)
				self.__timeout = gobject.timeout_add(value * 1000, self.update)
			else:
				# TODO: raise exception!!!
				pass

	def on_init (self):
		print "Screenlet has been initialized."
		# add zip code menu item 
		self.add_menuitem("zipcode", "城市")
		self.add_menuitem("mini", "精简模式切换")
		self.add_menuitem('refreshWeather','刷新天气信息')
		self.add_menuitem('gotoWeatherURL','访问中国天气网')
		self.add_menuitem('gotoSoftURL','检查更新...')
		
		self.add_default_menuitems()	
		self.update()

	def update(self):
		gobject.idle_add(self.update_weather_data)
		
		return True


	def update_weather_data(self):
		strFilename = self.get_screenlet_dir() + '/temp.bk~'
		try :
			statinfo = os.stat(strFilename)
			f=open(strFilename,"r")
			temp2=pickle.load(f)
			f.close()
		except :
			temp2=WeatherDataClass()
		if temp2.ZIP <> self.ZIP or temp2.Weather == [] or self.dateComp(statinfo.st_mtime) : #存储的临时文件无数据
			temp = self.parseWeatherData()
			if temp.Weather == [] :    ##did we get any data?  if not...
				if self.show_error_message == 1 and self.updated_recently == 1:
					self.show_error()
					self.updated_recently = 0
					return
			else:
				try:
					f=open(strFilename,"w")
					pickle.dump(temp,f)
					f.close()
				except:
					pass
				temp2=temp 
		self.latest = temp2
		self.latestHourly = self.parseWeatherDataHourly()
		self.updated_recently = 1
		self.redraw_canvas()

	def dateComp(self,fTime): #判断文件建立日期是在当天且8点之后
		mTime = datetime.datetime.fromtimestamp(fTime)
		mToday = datetime.datetime.today()
		bReturn = True
		if mToday.hour < 8 :
			if mTime.day == mToday.day or ( mTime.day == (mToday - datetime.timedelta(1)).day and mTime.hour >= 18 ) :
				bReturn = False
		elif mToday.hour < 18 :
			if mTime.day == mToday.day and mTime.hour >= 8 :
				bReturn = False
		else :
			if mTime.day == mToday.day and mTime.hour >= 18 :
				bReturn = False
		return bReturn


	def parseWeatherData(self):
		# 从网上获得天气信息
		forecast = WeatherDataClass()
		proxies = proxy.Proxy().get_proxy()
		try:
			forecast.ZIP = self.ZIP
			data = urlopen("http://search.weather.com.cn/static/url_gb.php?CityInfo="+ self.ZIP.encode("gb2312"),proxies=proxies).read() # 查询中国天气网得到城市ID
			self.strCityID = self.getBetween(data,"http://www.weather.com.cn/html/weather/",".shtml")
			if self.strCityID == '' or self.strCityID == '999999999' : raise
			data = urlopen("http://www.weather.com.cn/html/weather/"+self.strCityID+".shtml",proxies=proxies).read()
			# get SunRise and SunDown
			dcstart=data.find('日出时间')
			dcstart=data.find('<dd>',dcstart)+4
			dcstop=data.find('</a></dd>',dcstart)
			forecast.SunRise=datetime.datetime.strptime(data[dcstart:dcstop],"%Y-%m-%d %H:%M:%S")

			dcstart=data.find('日落时间',dcstop)
			dcstart=data.find('<dd>',dcstart)+4
			dcstop=data.find('</a></dd>',dcstart)
			forecast.SunDown=datetime.datetime.strptime(data[dcstart:dcstop],"%Y-%m-%d %H:%M:%S")
			#get day
			dcstart = data.find('<div class="box_contenttoday210">') 
			if dcstart <> -1 :
				dcstop = data.find('</p>',dcstart)
				data_current = data[dcstart:dcstop]
				forecast.Weather.append(self.tokenizeTomorrow(data_current))
				dateNow=datetime.datetime.strptime(self.getBetween(data,'未来2-7天天气预报（','发布）'),"%Y-%m-%d %H:%M")
				if (forecast.Weather[0]["date"]<>'今日'):
					dateNow=dateNow+ datetime.timedelta(1)
				forecast.Weather[0]["date"]= dateNow.strftime("%d日星期%a")

				dcstart = data.find('<div class="fut_weatherbox7">',dcstop)				
				while dcstart <> -1 :
					dcstop = data.find('</div>',dcstart)
					data_current = data[dcstart:dcstop]
					forecast.Weather.append(self.tokenizeDayWeather(data_current))
					dcstart = data.find('<div class="fut_weatherbox7">',dcstop)
		except:
			pass
		return forecast

	def parseWeatherDataHourly(self):
		hforecast = []
		try:
			
			proxies = proxy.Proxy().get_proxy()
			data = urlopen("http://search.weather.com.cn/static/url_gb.php?CityInfo="+ self.ZIP.encode("gb2312"),proxies=proxies).read() # 查询中国天气网得到城市ID
			self.strCityID = self.getBetween(data,"http://www.weather.com.cn/html/weather/",".shtml")
			if self.strCityID == '' or self.strCityID == '999999999' : raise
			data = urlopen('http://www.weather.com.cn/data/sk/'+self.strCityID+'.html',proxies=proxies).read() #得到实况数据
			hforecast.append(self.tokenizeForecastHourly(data))
		except :
			pass

		return hforecast

	def tokenizeTomorrow(self,data):
		tokenized = {
		'date' : self.getBetween(data, '<a onmouseover="javascript:menu(1,1)">','天气预报'),
		'iconDay' : self.getBetween(data, '<img src="/m/i/icon_weather/42x30/','.gif" />')[1:],
		'iconNight' : self.getBetween(data, '&nbsp;&nbsp;<img src="/m/i/icon_weather/42x30/','.gif" />')[1:],
		'weather' : self.getBetween(data,'<em><strong>','</strong></em>'),
		'tempHigh' : self.getBetween(data, '<em class="no_today">','℃'),
		'tempLow' : self.getBetween(data, '℃/ ','℃</em>'),
		'wind' : self.getReverseBetween(data, '<em>','</em><br/>'),
		}
		return tokenized

	def tokenizeDayWeather(self,data):
		tokenized = {
		'date' : self.getBetween(data, '<h3>','</h3>'),
		'iconDay' : self.getBetween(data, '<img src="/m/i/icon_weather/42x30/','.gif" />')[1:],
		'iconNight' : self.getBetween(data, '&nbsp;&nbsp;<img src="/m/i/icon_weather/42x30/','.gif" />')[1:],
		'weather' : self.getBetween(data,'<h4 class="temp00_dn">','</h4>'),
		'tempHigh' : self.getBetween(data, '高温：','℃'),
		'tempLow' : self.getBetween(data, '低温：','℃'),
		'wind' : self.getBetween(data, '<h4 class="temp03_dn">','</h4>'),
		}
		return tokenized


	def tokenizeForecastHourly(self, data):
		tokenized = {
		'temp' : self.getBetween(data, 'temp":"','"'),
		'wd': self.getBetween(data, 'WD":"','"'),
		'ws': self.getBetween(data, 'WS":"','"'),
		'sd': self.getBetween(data, 'SD":"','"'),
		'time': self.getBetween(data, 'time":"','"'),
		'sm': self.getBetween(data, 'sm":"','"')
		}
		return tokenized

	def getBetween(self, data, first, last):
		x = len(first)
		begin = data.find(first) +x
		end = data.find(last, begin)
		return data[begin:end]
	

	def getReverseBetween(self, data, first, last):
		x = len(first)
		begin = data.rfind(first) +x
		end = data.find(last, begin)
		return data[begin:end]

	def get_CurIcon(self,iconDay):
		nHour=datetime.datetime.now()
		if (nHour >= self.latest.SunRise and nHour < self.latest.SunDown) or (int(iconDay) > 5 and int(iconDay) <> 13 ) :
			strIcon='d'+iconDay
		else:
			strIcon='n'+iconDay
		return strIcon



	def on_draw(self, ctx):
		weather = self.latest.Weather
		hourly = self.latestHourly
		nWeatherLen=len(weather)
		degree = unichr(176)
		# set size
		ctx.scale(self.scale, self.scale)
		# draw bg (if theme available)
		ctx.set_operator(cairo.OPERATOR_OVER)
		ctx.set_source_rgba(*self.background_color)
		if self.theme:
			s = self.theme.path
			if (self.mini == False ):
				self.theme.render(ctx,'weather-bg')
				
				if self.theme_name == 'default':self.draw_rounded_rectangle(ctx,11.5,18.5,8,120,80)
				self.theme.render(ctx,'weather-bg')
			else:
				if self.theme_name == 'default':self.draw_rounded_rectangle(ctx,11.5,18.5,8,120,41.8)
				self.theme.render(ctx,'weather-bg-mini')
				
		ctx.set_source_rgba(*self.font_color)
		# draw memory-graph
		if self.theme:
			if weather == []:
				
				self.draw_text(ctx,'<b>正在查询数据...</b>', 15, 25, self.font.split(' ')[0], 7,  self.width,pango.ALIGN_LEFT)

			else:

				ctx.save()
				ctx.translate(-2, 0)
				ctx.scale(.6,.6)
				icon = self.get_CurIcon(weather[0]["iconDay"])
				self.draw_scaled_image(ctx,0,0,self.theme.path + '/' + icon+ '.png',110,110)
				ctx.restore()

				ctx.save()
				if hourly == [] or hourly[0]["temp"] == '暂无实况': #不存在实时数据
					self.draw_text(ctx, '<b>'+weather[0]["tempLow"]+'/'+weather[0]["tempHigh"]+degree+'</b>', 35,22, self.font.split(' ')[0],12,  self.width,pango.ALIGN_CENTER)
					self.draw_text(ctx,'<b>' + self.latest.ZIP +'</b>', 30,44, self.font.split(' ')[0],12-(len(self.latest.ZIP)/3), self.width,pango.ALIGN_CENTER)
				else:
					self.draw_text(ctx, '<b>'+weather[0]["tempLow"]+degree+'</b>', 63,26, self.font.split(' ')[0], 5,  self.width,pango.ALIGN_LEFT)
					self.draw_text(ctx, '<b>'+weather[0]["tempHigh"]+degree+'</b>', 63,33, self.font.split(' ')[0], 5,  self.width,pango.ALIGN_LEFT)
					self.draw_text(ctx, '<b>'+hourly[0]["sd"]+'</b>', 63,40, self.font.split(' ')[0], 5,  self.width,pango.ALIGN_LEFT)
					self.draw_text(ctx, '<b>'+hourly[0]["temp"]+degree+'</b>', 40,22, self.font.split(' ')[0], 12,  self.width,pango.ALIGN_CENTER)
					self.draw_text(ctx,'<b>' + self.latest.ZIP +'</b>', 35,44, self.font.split(' ')[0],12-(len(self.latest.ZIP)/3), self.width,pango.ALIGN_CENTER)
				ctx.restore()

				if (self.mini == False):
			
					ctx.save() 
					ctx.translate(16, 60)
					self.theme.render(ctx,'day-bg')
					i = 1
					while i < nWeatherLen :
						self.draw_text(ctx,'<b>' +weather[i]["date"][:len(weather[i]["date"])-9]+ '</b>', 0,0, self.font.split(' ')[0],5, self.width,pango.ALIGN_LEFT)
						ctx.translate(30, 0)
						i += 1
					ctx.restore()	

					ctx.save()
					ctx.translate(14, 68)
					i = 1
					
					while i < nWeatherLen :
						self.draw_scaled_image(ctx,0,0,self.theme.path + '/d' +weather[i]["iconDay"]+ '.png',22,22)
						ctx.translate(30,0)
						i += 1
					ctx.restore()						
					if self.show_daytemp == True:
						ctx.save()	
						ctx.translate(16,90)
						i = 1
						while i < nWeatherLen :
							self.draw_text(ctx,'<b>'+ weather[i]["tempLow"]+'/'+weather[i]["tempHigh"]+degree+'</b>', 0,0, self.font.split(' ')[0], 5, self.width,pango.ALIGN_LEFT)
							ctx.translate(30, 0)
							i += 1
						ctx.restore()

	
	def on_mouse_move (self,event):
		self.hide_tooltip()
	
	def on_unfocus(self, event):
		self.hide_tooltip()

	def on_mouse_down(self,event):
		if self.bShowTip and event.button == 1:
			self.detect_button(event.x / self.scale ,  event.y / self.scale)
			self.cancel_show_Tooltip()
			self.ShowWeatherDetail()
			self.tooltipDelay = gobject.timeout_add(2500, self.hide_tooltip)

        def cancel_show_Tooltip (self): 
		if self.tooltipDelay: 
	                gobject.source_remove(self.tooltipDelay) 

	def my_show_tooltip (self,text,tooltipx,tooltipy) :
		if self.tooltip == None:
			self.tooltip = screenlets.Tooltip(150, 100) 
			self.tooltip.text = text 
			self.tooltip.x = tooltipx 
			self.tooltip.y = tooltipy 
			self.tooltip.show() 

	def detect_button(self, x, y):
		#根据位置判断提示类型
		button_det = 0
		if y >= 18.5 and y <= 63:
			button_det=0
		elif y > 63 :
			if x < 41.5 :
				button_det = 1
			elif x < 71.5 :
				button_det = 2
			elif x < 101.5 :
				button_det = 3
			else:
				button_det = 4
		self.buttonDet=button_det

	def ShowWeatherDetail(self) :
		#显示提示
 		self.my_show_tooltip( self.GetWeatherDetail(self.buttonDet),self.x+self.mousex,self.y+self.mousey)
		


	def GetWeatherDetail(self,iButton):
		if self.latest.ZIP == '' :
			strTooltip = "没有数据，请检查网络连接"
		else :
			degree = unichr(176)
			if iButton >= len(self.latest.Weather): iButton = 0
			strWeather = self.latest.Weather[iButton]
			if iButton == 0  and self.latestHourly <> [] and self.latestHourly[0]["temp"] <> '暂无实况' :
				strWeatherHourly = self.latestHourly[0]
				strTooltip = "  ----实时天气("+strWeatherHourly["time"]+ ")----"+'\n'
				strTooltip += "温度："+strWeatherHourly["temp"]+  degree+ 'C\n'
				strTooltip += "湿度："+strWeatherHourly["sd"]+ '\n'
				strTooltip += "风向："+strWeatherHourly["wd"]+ '\n'
				strTooltip += "风力："+strWeatherHourly["ws"]+ '\n'
				strTooltip += "风速："+strWeatherHourly["sm"]+'m/s'+ '\n'
				strTooltip += "  ----天气预报----" + '\n'
			else :
				strTooltip = "  ----天气预报----" + '\n'
			strTooltip += "日期： "+strWeather["date"] + '\n'
			strTooltip += "天气： "+strWeather["weather"] + '\n'
			strTooltip += "低温： "+strWeather["tempLow"] + degree+ 'C\n'
			strTooltip += "高温： "+strWeather["tempHigh"] + degree+'C\n'
			strTooltip += "风力： "+strWeather["wind"] + '\n'


		return strTooltip

	def on_draw_shape(self,ctx):
		if self.theme:
			# set size rel to width/height
			self.on_draw(ctx)

	def menuitem_callback(self, widget, id):
		screenlets.Screenlet.menuitem_callback(self, widget, id)
		if id=="zipcode":
			self.show_edit_dialog()
		elif id == "mini":
			self.mini = not self.mini
			self.update()
		elif id == "refreshWeather":
			 self.update_weather_data()
		elif id == "gotoWeatherURL":
			 os.system('xdg-open http://www.weather.com.cn/html/weather/'+self.strCityID+".shtml")
		elif id == "gotoSoftURL":
			 os.system('xdg-open http://www.gnome-look.org/content/show.php/ChinaClearWeather?content=92657')

			


	def show_edit_dialog(self):
		# create dialog
		dialog = gtk.Dialog("城市名称", self.window)
		dialog.resize(300, 100)
		dialog.add_buttons(gtk.STOCK_OK, gtk.RESPONSE_OK, 
			gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
		entrybox = gtk.Entry()
		entrybox.set_text(str(self.ZIP))
		dialog.vbox.add(entrybox)
		entrybox.show()	
		# run dialog
		response = dialog.run()
		if response == gtk.RESPONSE_OK:
			self.ZIP = entrybox.get_text()
			self.updated_recently = 1
		dialog.hide()
		#self.update()





	def show_error(self):

		dialog = gtk.Dialog("错误", self.window)
		dialog.resize(300, 100)
		dialog.add_buttons(gtk.STOCK_OK, gtk.RESPONSE_OK)

		label = gtk.Label("错误：无法获得数据，\n请检查你的网络连接或城市名称是否正确。\n正在显示的是以前保存的信息。\n")
		dialog.vbox.add(label)
		check = gtk.CheckButton("不要再显示")
		dialog.vbox.add(check)
		dialog.show_all()
		response = dialog.run()
		if response == gtk.RESPONSE_OK:
			if check.get_active() == True:
				self.show_error_message = 0			
			dialog.hide()

	

if __name__ == "__main__":
	import screenlets.session
	screenlets.session.create_session(ChinaClearWeatherScreenlet)
